# EPINETLAB

EPINETLAB is a multi-Graphic User Interface (GUI) set of Matlab functions developed in the context of the EPIleptic NETworks project (EPINET, http://cordis.europa.eu/project/rcn/195032_en.html), an EU-funded initiative focussed to developing tools for the detection of high-frequency oscillations (HFOs) in intracranial EEG (iEEG) and source-space MEG data and to their application to the improvement of the delineation of the seizure-onset zone (SOZ). EPINETLAB was developed as a plugin toolbox for EEGLAB, under the GNU Public License version 3.0. EPINETLAB was designed to provide an easy-to-use tool to investigate the spatial and time-frequency properties of HFOs, to identify the channels with the highest HFO-rate and to allow the evaluation of the spatial distribution of the HFO area with that of the SOZ identified in the presurgical workup. The toolbox was documented for each step of the analysis pipeline and parameters for the analyses can be set in user-friendly GUIs. 
Moreover, the platform allows analysis of multiple files in a single process and the implementation of a robust channel reduction methodology was designed to reduce computational load and subject-dependent errors. An addition not available in other tools released in the literature is the possibility to load, process and analyse MEG data, either raw or source-space domain, thus providing the possibility to evaluate the concordance between the source locations of HFOs recorded from pre-operative MEG studies and those identified in iEEG recordings. Each function in EPINETLAB underwent a rigorous beta-testing phase with neurophysiology clinical scientists (EEG Technologists) and clinical neurophysiologists, to simulate real-life operator-dependent situations and minimize programming errors caused by unforeseen list of operations.

EPINETLAB is being developed since 2015 at the Aston University, Aston Brain Centre, Birmingham, UK, by Dr. Lucia Rita Quitadamo, senior researcher at the School of Life and Health Sciences department. The project was funded by EC, under the Marie Sklodowska-Curie actions-International fellowships (IF). For any enquiry about the software please contact l.quitadamo@aston.ac.uk.

References: 

[1]Quitadamo LR, Mai R, Gozzo F, Pelliccia V, Cardinale F, Seri S. Kurtosis-based detection of intracranial high-frequency oscillations for the identification of the seizure onset zone Int J Neural Syst 2018, Accepted for publication.

[2]Quitadamo LR, Mai R, Seri S. Identification of high-frequency oscillations (HFOs) in paediatric intracranial EEG by means of kurtosis-based time-frequency analysis. Epilepsia 2017, 58:S97-S98.

[3]Foley E, Quitadamo L, Hillebrand A, Bill P, Seri S. High Frequency Oscillations detected by automatic Kurtosis-based Time-Frequency analysis in MEG And Intracranial EEG in Paediatric Epilepsy. Epilepsia 2017, 58:S152-S152.
